Bug 1953537 - python-asyncio-dgram fails to build with Python 3.10: AssertionError: Regex pattern 'must be SocketKind.SOCK_DGRAM' does not match 'socket type must be SOCK_DGRAM'.
Summary: python-asyncio-dgram fails to build with Python 3.10: AssertionError: Regex p...
Keywords:
Status: CLOSED WORKSFORME
Alias: None
Product: Fedora
Classification: Fedora
Component: python-asyncio-dgram
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Fabian Affolter
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1968902 (view as bug list)
Depends On:
Blocks: F35FTBFS F35FailsToInstall PYTHON3.10 1968886 1969115
TreeView+ depends on / blocked
 
Reported: 2021-04-26 10:38 UTC by Tomáš Hrnčiar
Modified: 2021-07-12 12:44 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-07-12 12:44:39 UTC
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2021-04-26 10:38:20 UTC
python-asyncio-dgram fails to build with Python 3.10.0a7.

=================================== FAILURES ===================================
_________________________ test_from_socket_bad_socket __________________________

monkeypatch = <_pytest.monkeypatch.MonkeyPatch object at 0x7f71f2c53fa0>

    @pytest.mark.asyncio
    async def test_from_socket_bad_socket(monkeypatch):
        class MockSocket:
            family = socket.AF_PACKET
    
        with monkeypatch.context() as m:
            m.setattr(socket, "socket", lambda _, __: MockSocket())
            sock = socket.socket(socket.AF_UNIX, socket.SOCK_DGRAM)
            with pytest.raises(TypeError, match="socket family not one of"):
                await asyncio_dgram.from_socket(sock)
    
        with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as sock:
            with pytest.raises(TypeError, match="must be SocketKind.SOCK_DGRAM"):
>               await asyncio_dgram.from_socket(sock)

test/test_aio.py:251: 
_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ 

sock = <socket.socket [closed] fd=-1, family=AF_INET, type=SOCK_STREAM, proto=0>

    async def from_socket(sock):
        """
        Create a DatagramStream from a socket.  This is meant to be used in cases
        where the defaults set by `bind()` and `connect()` are not desired and/or
        sufficient.  If `socket.connect()` was previously called on the socket,
        then an instance of DatagramClient will be returned, otherwise an instance
        of DatagramServer.
    
        @param sock - socket to use in the DatagramStream.
        @return     - A DatagramClient for connected sockets, otherwise a
                      DatagramServer.
        """
        loop = asyncio.get_event_loop()
        recvq = asyncio.Queue()
        excq = asyncio.Queue()
        drained = asyncio.Event()
    
        supported_families = tuple((socket.AF_INET, socket.AF_INET6, socket.AF_UNIX))
    
        if sock.family not in supported_families:
            raise TypeError(
                "socket family not one of %s"
                % (", ".join(str(f) for f in supported_families))
            )
    
        if sock.type != socket.SOCK_DGRAM:
>           raise TypeError("socket type must be %s" % (socket.SOCK_DGRAM,))
E           TypeError: socket type must be SOCK_DGRAM

../../BUILDROOT/python-asyncio-dgram-1.1.1-2.fc35.x86_64/usr/lib/python3.10/site-packages/asyncio_dgram/aio.py:282: TypeError

During handling of the above exception, another exception occurred:

monkeypatch = <_pytest.monkeypatch.MonkeyPatch object at 0x7f71f2c53fa0>

>   ???
E   AssertionError: Regex pattern 'must be SocketKind.SOCK_DGRAM' does not match 'socket type must be SOCK_DGRAM'.

test/test_aio.py:-1: AssertionError
=========================== short test summary info ============================
FAILED test/test_aio.py::test_from_socket_bad_socket - AssertionError: Regex ...
================== 1 failed, 18 passed, 1 deselected in 0.88s ==================

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/02148391-python-asyncio-dgram/

For all our attempts to build python-asyncio-dgram with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-asyncio-dgram/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Miro Hrončok 2021-06-04 20:13:36 UTC
This is a mass-posted update. Sorry if it is not 100% accurate to this bugzilla.


The Python 3.10 rebuild is in progress in a Koji side tag. If you manage to fix the problem, please commit the fix in the rawhide branch, but don't build the package in regular rawhide.

You can either build the package in the side tag, with:

    $ fedpkg build --target=f35-python

Or you can the build and we will eventually build it for you.

Note that the rebuild is still in progress, so not all (build) dependencies of this package might be available right away.

Thanks.

See also https://fedoraproject.org/wiki/Changes/Python3.10

If you have general questions about the rebuild, please use this mailing list thread: https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/thread/G47SGOYIQLRDTWGOSLSWERZSSHXDEDH5/

Comment 2 Miro Hrončok 2021-06-07 22:58:22 UTC
The f35-python side tag has been merged to Rawhide. From now on, build as you would normally build.

Comment 3 Miro Hrončok 2021-06-08 11:22:20 UTC
*** Bug 1968902 has been marked as a duplicate of this bug. ***

Comment 4 Miro Hrončok 2021-06-15 20:27:09 UTC
Hello,

This is the first reminder (step 3 from https://docs.fedoraproject.org/en-US/fesco/Fails_to_build_from_source_Fails_to_install/#_package_removal_for_long_standing_ftbfs_and_fti_bugs).

If you know about this problem and are planning on fixing it, please acknowledge so by setting the bug status to ASSIGNED. If you don't have time to maintain this package, consider orphaning it, so maintainers of dependent packages realize the problem.

Comment 5 Miro Hrončok 2021-07-07 11:36:54 UTC
Hello,

This is the second reminder (step 4 from https://docs.fedoraproject.org/en-US/fesco/Fails_to_build_from_source_Fails_to_install/#_package_removal_for_long_standing_ftbfs_and_fti_bugs).

If you know about this problem and are planning on fixing it, please acknowledge so by setting the bug status to ASSIGNED. If you don't have time to maintain this package, consider orphaning it, so maintainers of dependent packages realize the problem.

Comment 6 Fedora Release Engineering 2021-07-11 04:22:44 UTC
Dear Maintainer,

your package has an open Fails To Build From Source bug for Fedora 35.
Action is required from you.

If you can fix your package to build, perform a build in koji, and either create
an update in bodhi, or close this bug without creating an update, if updating is
not appropriate [1]. If you are working on a fix, set the status to ASSIGNED to
acknowledge this. If you have already fixed this issue, please close this Bugzilla report.

Following the policy for such packages [2], your package will be orphaned if
this bug remains in NEW state more than 8 weeks (not sooner than 2021-06-21).

A week before the mass branching of Fedora 36 according to the schedule [3],
any packages not successfully rebuilt at least on Fedora 34 will be
retired regardless of the status of this bug.

[1] https://docs.fedoraproject.org/en-US/fesco/Updates_Policy/
[2] https://docs.fedoraproject.org/en-US/fesco/Fails_to_build_from_source_Fails_to_install/
[3] https://fedorapeople.org/groups/schedule/f-36/f-36-key-tasks.html

Comment 7 Miro Hrončok 2021-07-12 11:52:30 UTC
The package no longer fails to build with Python 3.10.0b4.

I will take care of the rebuild.

Please note that the standard library enum implementation was reverted upstream to the Python 3.9 version; if the failure was enum related (such as tests expecting a specific Enum.__repr__ value) it will likely happen again with Python 3.11.

https://mail.python.org/archives/list/python-dev@python.org/message/LSTMFAPSPD3BGZ4D6HQFODXZVB3PLYKF/

Comment 8 Miro Hrončok 2021-07-12 12:44:39 UTC
Hello,

Please note that this comment was generated automatically. If you feel that this output has mistakes, please contact me via email (mhroncok).

All subpackages of a package against which this bug was filled are now installable or removed from Fedora 35.

Thanks for taking care of it!


Note You need to log in before you can comment on or make changes to this bug.